process Watchdog =
     { integer DELAY; }
     ( ? event order;
         event finish;
         event tick;
       ! integer alarm;
     )
     unsafe
   (| hour := (hour$ init 0)+1
    | cnt := (DELAY when (^order)) default (DEFVALUE when (^finish)) default ((zcnt-1) when (0<zcnt)) default DEFVALUE
    | cnt ^= order ^+ finish ^+ tick
    | zcnt := cnt$ init 0
    | hour ^= tick
    | alarm := hour when (cnt=0)
    |)
   where 
   constant integer DEFVALUE = -1;
   integer hour;
   integer cnt;
   integer zcnt;
   end
%Watchdog%; 
